#29/06/2009
#Hawkes process intensity function lambda(t)=lambda(t_{k+1}), t_k<t<t_{k+1}
#MMHP 090629
#Times begins with t_0 =0.
HawkesStep.cif <- function (data, eval.pts, params, TT = NA, t.plus = FALSE) 
{
    lamb <- params[1]
    nu <- params[2]
    eta <- params[3]
    if (is.null(data)) 
        data <- cbind(time = Inf, magnitude = 0)
    magnitudes <- data[, "magnitude"]
    times <- data[, "time"]
    if (any(is.na(TT))) {
        if (is.vector(eval.pts)) 
            eval.times <- eval.pts
        else eval.times <- eval.pts[, "time"]
        if (length(eval.times) > 1) {
            St <- apply(t(eval.times), 2, function(z, magnitudes, 
                times, lamb, nu, eta, t.plus) {
                if (!t.plus) 
                  use <- times < max(times[times<z])
                else use <- times <= max(times[times<z])
                if (sum(use) > 0) 
                  sum( exp( - eta * ( max(times[times<z]) - times[use] ) ) )
                else 0
            }, magnitudes = magnitudes, times = times, lamb = lamb, 
                nu = nu, eta = eta, t.plus = t.plus)
        }
        else {
            if (!t.plus) 
                use <- times < max(times[times<eval.times])
            else use <- times <= max(times[times<eval.times])
            if (sum(use) > 0) 
                St <- sum( exp( - eta * ( max(times[times<eval.times]) - times[use] ) ) )
            else St <- 0
        }
        ci <- lamb + nu * eta * St
    }
    else {
        S <- c(NA, NA)
        for (Ii in 1:2) {
            Z0 <- (times <= TT[Ii])
            if (any(Z0)) {
            St <- apply(t(times), 2, function(z, magnitudes, 
                times, lamb, nu, eta, t.plus) {
                if (!t.plus) 
                  use <- times < max(times[times<z])
                else use <- times <= max(times[times<z])
                if (sum(use) > 0) 
                  nu * eta * sum( exp( - eta * ( max(times[times<z]) - times[use] ) ) )
                else 0
            }, magnitudes = magnitudes, times = times, lamb = lamb, 
                nu = nu, eta = eta, t.plus = t.plus)
            xi <- c(diff(c(0,times[times<=TT[Ii]])),TT[Ii]-max(times[times<=TT[Ii]]))
                  S[Ii] <- sum( St*xi )
            }else S[Ii] <- 0
        }
        ci <- lamb*(TT[2]-TT[1]) + (S[2] - S[1])
    }
    names(ci) <- NULL
    return(ci)
}
attr(HawkesStep.cif, "rate") <- "decreasing"
attr(HawkesStep.cif, "type") <- "default"

