#29/06/2009
mmhp <- function (ti, lamb0, nu0, eta0, Q0, pai0, nlmp = TRUE, fortran = TRUE) 
{
    library(Matrix)
    n <- length(ti) - 1
    r <- length(lamb0)
    xi <- ti[2:(n + 1)] - ti[1:n]
    lamb <- lamb0
    nu <- nu0
    eta <- eta0
    Q <- Q0
    pai <- pai0
    repeat {
        sums <- matrix(as.double(0), n, r)
        lamL <- matrix(as.double(0), n, r)
        LamU <- array(as.double(0), dim = c(n, r, r))
        lamstar <- .Fortran("lamstar", as.integer(r), as.integer(n), 
            as.double(lamb), as.double(nu), as.double(eta), as.double(ti), 
            sums, lamL, LamU, PACKAGE = "MMHP")
        names(lamstar) <- c("r", "n", "lamb", "nu", "eta", "ti", 
            "sums", "lams", "Lamst")
        lams <- lamstar$lams
        Lamst <- lamstar$Lamst
        S <- array(as.double(0), dim = c(n, r, r))
        Sinv <- array(as.double(0), dim = c(n, r, r))
        post <- array(as.double(0), dim = c(n, r, r))
        eigenval <- matrix(as.double(0), n, r)
        for (i in 1:n) {
            decomp <- eigen(Q - Lamst[i, , ], symmetric = FALSE)
            if (any(duplicated(decomp$values))) 
                stop("repeated eigenvalues")
            S[i, , ] <- decomp$vectors
            Sinv[i, , ] <- solve(S[i, , ])
            post[i, , ] <- Sinv[i, , ] %*% Lamst[i, , ]
            eigenval[i, ] <- decomp$values
        }
        fk <- array(as.double(0), dim = c(n, r, r))
        expmt <- array(as.double(0), dim = c(n, r, r))
        Ln <- matrix(as.double(0), n + 1, r)
        Lfk <- matrix(as.double(0), n, r)
        Lfksum <- rep(as.double(0), n)
        RR <- matrix(as.double(0), n + 1, r)
        Rfk <- matrix(as.double(0), n, r)
        tem <- matrix(as.double(0), n, r)
        C <- array(as.double(0), dim = c(n, 2 * r, 2 * r))
        Cfun <- .Fortran("Cfun", as.integer(r), as.integer(n), 
            fk, RR, Rfk, Ln, Lfk, Lfksum, S, Sinv, eigenval, 
            Lamst, post, as.double(xi), expmt, as.double(pai), 
            as.double(Q), tem, C, PACKAGE = "MMHP")
        names(Cfun) <- c("r", "n", "fk", "RR", "Rfk", "L", "Lfk", 
            "Lfksum", "S", "Sinv", "eigenval", "Lamst", "post", 
            "xi", "expmt", "pai", "Q", "tem", "C")
        C <- Cfun$C
        Lamst <- Cfun$Lamst
        L <- Cfun$L
        R <- Cfun$RR
        Ik <- array(as.double(0), dim = c(n, r, r))
        for (k in 1:n) {
            Ik[k, , ] <- (as.matrix(expm(Matrix(C[k, , ] * xi[k])))[1:r, 
                (r + 1):(2 * r)])
        }
        Icn <- matrix(as.double(0), r, r)
        wn <- matrix(as.double(0), r, r)
        Dn <- rep(as.double(0), r)
        wDfun <- .Fortran("wDfun", as.integer(r), as.integer(n), 
            fk, Ln, Lfk, Lfksum, S, Sinv, eigenval, Lamst, post, 
            as.double(xi), expmt, as.double(pai), Ik, Icn, as.double(Q), 
            wn, Dn, PACKAGE = "MMHP")
        names(wDfun) <- c("r", "n", "fk", "L", "Lfk", "Lfksum", 
            "S", "Sinv", "eigenval", "Lamst", "post", "xi", "expmt", 
            "pai", "Ik", "Ic", "Q", "w", "D")
        Ic <- wDfun$Ic
        Lfksum <- wDfun$Lfksum
        w <- wDfun$w
        D <- wDfun$D
        LL <- as.double(0)
        LL1 <- .Fortran("LL1", as.integer(r), as.integer(n), 
            fk, Ln, Lfk, Lfksum, S, Sinv, eigenval, Lamst, post, 
            as.double(xi), expmt, as.double(pai), LL, PACKAGE = "MMHP")
        names(LL1) <- c("r", "n", "fk", "L", "Lfk", "Lfksum", 
            "S", "Sinv", "eigenval", "Lamst", "post", "xi", "expmt", 
            "pai", "LL")
        LLo <- LL1$LL
        hatQ <- matrix(as.double(0), r, r)
        for (i in 1:r) {
            for (j in 1:r) {
                hatQ[i, j] <- w[i, j]/D[i]
            }
            hatQ[i, i] <- -(sum(hatQ[i, ]) - hatQ[i, i])
        }
        hatpai <- rep(as.double(0), r)
        for (i in 1:r) {
            hatpai[i] <- pai[i] * R[1, i]
        }
        Bn <- matrix(as.double(0), r, n)
        Bfun <- .Fortran("Bfun", as.integer(r), as.integer(n), 
            fk, RR, Rfk, Ln, Lfk, Lfksum, S, Sinv, eigenval, 
            Lamst, post, as.double(xi), expmt, as.double(pai), 
            Bn, PACKAGE = "MMHP")
        names(Bfun) <- c("r", "n", "fk", "RR", "Rfk", "L", "Lfk", 
            "Lfksum", "S", "Sinv", "eigenval", "Lamst", "post", 
            "xi", "expmt", "pai", "Bn")
        B <- Bfun$Bn
        Q2f <- function(param) {
            dumlam <- param[1:r]
            dumnu <- param[(r + 1):(2 * r)]
            dumeta <- param[(2 * r + 1):(3 * r)]
            elamb <- exp(dumlam)
            enu <- exp(-exp(-dumnu))
            eeta <- exp(dumeta)
            St1 <- St2 <- St3 <- matrix(0,r,n)
            Q2 <- rep(0,r)
            for (i in 1:r){
              St1[i,] <- apply(t(ti[-(n+1)]), 2, 
                 function(z, elamb, enu, eeta, ti) {
                  use <- ti < z
                  if (sum(use) > 0){
                    log(elamb[i] + enu[i] * eeta[i] * 
                      sum(exp(-eeta[i] * (z - ti[use]))))
                  } else log(elamb[i])
                 },elamb=elamb, enu=enu, eeta=eeta, ti=ti)
              St2[i,] <- apply(t(ti[-(n+1)]), 2, 
                 function(z, elamb, enu, eeta, ti) {
                  use <- ti < z
                  if (sum(use) > 0){
                    elamb[i] + enu[i] * eeta[i] * 
                      sum(exp(-eeta[i] * (z - ti[use])))
                  } else elamb[i]
                 },elamb=elamb, enu=enu, eeta=eeta, ti=ti) 
              Q2[i] <- sum( B[i,] * St1[i,]) - 
                        sum(St2[i,] * Ik[,i,i] / Lfksum )
            } 
            Q22 <- -sum(Q2)
            return(Q22)
        }
        if (nlmp != TRUE) {
            lamnueta <- optim(c(log(lamb), -log(-log(nu)), log(eta)), 
                Q2f, gr = NULL)
#            if (lamnueta$convergence < 0.5) {
                hparam <- lamnueta$par
                hatlamb <- exp(hparam[1:r])
                hatnu <- exp(-exp(-hparam[(r + 1):(2 * r)]))
                hateta <- exp(hparam[(2 * r + 1):(3 * r)])
#            }else stop("Worse Newton iteration")
        }else {
            pa <- c(log(lamb), -log(-log(nu)), log(eta))
            lamnueta <- nlm(Q2f, pa, steptol=1e-6,print.level=1, iterlim = 100)
            if (lamnueta$code < 3.5) {
                hparam <- lamnueta$estimate
                hatlamb <- exp(hparam[1:r])
                hatnu <- exp(-exp(-hparam[(r + 1):(2 * r)]))
                hateta <- exp(hparam[(2 * r + 1):(3 * r)])
            }else stop("Worse Newton iteration")
        }
        lamb <- hatlamb
        nu <- hatnu
        eta <- hateta
        Q <- hatQ
        pai <- hatpai
        sums <- matrix(as.double(0), n, r)
        lamL <- matrix(as.double(0), n, r)
        LamU <- array(as.double(0), dim = c(n, r, r))
        lamstn <- .Fortran("lamstar", as.integer(r), as.integer(n), 
            as.double(lamb), as.double(nu), as.double(eta), as.double(ti), 
            sums, lamL, LamU, PACKAGE = "MMHP")
        names(lamstn) <- c("r", "n", "lamb", "nu", "eta", "ti", 
            "sums", "lams", "Lamst")
        lamsn <- lamstn$lams
        Lamstn <- lamstn$Lamst
        Sn <- array(as.double(0), dim = c(n, r, r))
        Sinvn <- array(as.double(0), dim = c(n, r, r))
        postn <- array(as.double(0), dim = c(n, r, r))
        eigenvn <- matrix(as.double(0), n, r)
        for (i in 1:n) {
            decomp <- eigen(Q - Lamstn[i, , ], symmetric = FALSE)
            if (any(duplicated(decomp$values))) 
                stop("repeated eigenvalues")
            Sn[i, , ] <- decomp$vectors
            Sinvn[i, , ] <- solve(Sn[i, , ])
            postn[i, , ] <- Sinvn[i, , ] %*% Lamstn[i, , ]
            eigenvn[i, ] <- decomp$values
        }
        fk <- array(as.double(0), dim = c(n, r, r))
        expmt <- array(as.double(0), dim = c(n, r, r))
        Ln <- matrix(as.double(0), n + 1, r)
        Lfk <- matrix(as.double(0), n, r)
        Lfksum <- rep(as.double(0), n)
        LL <- as.double(0)
        LL2 <- .Fortran("LL1", as.integer(r), as.integer(n), 
            fk, Ln, Lfk, Lfksum, Sn, Sinvn, eigenvn, Lamstn, 
            postn, as.double(xi), expmt, as.double(pai), LL, 
            PACKAGE = "MMHP")
        names(LL2) <- c("r", "n", "fk", "L", "Lfk", "Lfksum", 
            "S", "Sinv", "eigenval", "Lamst", "post", "xi", "expmt", 
            "pai", "LL")
        LLn <- LL2$LL
        lamb <- hatlamb
        nu <- hatnu
        eta <- hateta
        Q <- hatQ
        pai <- hatpai
        if (LLn < LLo) stop ('worse likelihood') 
        if (LLn - LLo < 1e-04) 
            break
        print(Q)
        print(lamb)
        print(nu)
        print(eta)
        print(pai)
        print(LLo)
        print(LLn)
    }
    return(list(lamb = lamb, nu = nu, eta = eta, Q = Q, pai = pai, 
        LLo = LLo, LLn = LLn))
#    return(c(lamb, nu, eta, Q[1,2],Q[2,1],LLn))
}

