simulatemmhp <- function ( n, object, data, initial, nsim = 1, seed = NULL) 
{
    if (!is.null(seed)) 
        set.seed(seed)
    m <- ncol(object$Q)
    Q <- object$Q
    lambda <- object$lambda
    nu <- object$nu
    eta <- object$eta
    m <- ncol(Q)
    Pi <- diag(m) - diag(1/diag(Q)) %*% Q
    y <- NULL
    y[1] <- ytrans <- initial
    ys <- NULL
    ttrans <- 0
#    if (!is.null(data)) {
#        use <- (data[, "time"] < TT[1])
#        if (sum(use) == 0) 
#            data <- NULL
#        else data <- data[use, c("time")]
#    }
    tiall <- ti <- ts <- 0
    data <- rbind(data, c(time = ti, magnitude = 0))
    yi <- y[1]
    i <- 0
    s <- 0
    repeat {
         params <- c(lambda[yi],nu[yi],eta[yi])
         Rate <- -Q[yi,yi] + lambda[yi]+nu[yi]*eta[yi]*
              sum(exp(-eta[yi]* ( ti - tiall[tiall<ti] )))
         tau <- rexp(1, rate = Rate)
         ts <- ts + tau
         uradm <- runif(1, 0, 1)
         if (uradm > -Q[yi,yi]/Rate){
           i <- i + 1
           yi <- yi
           ys[i] <- yi
           ti <- ts
           data <- rbind(data, c(time = ti, magnitude = 0))
           tiall <- append(tiall,ti)
         }
         if (uradm <= -Q[yi,yi]/Rate){
           ytem <- sample(x = 1:m, size = 1, prob = Pi[yi, ])
           ytrans <- append(ytrans, ytem)
           yi <- ytem
           ttrans <- append(ttrans,ti)
         }
         if (i == n-1) break
    }
    object$data <- data
    object$ys <- ys
    object$ttrans <- ttrans
    object$ytrans <- ytrans
    return(object)
}
