\name{HawkesStep.cif}
\alias{HawkesStep.cif}
\title{ Intensity Function of a Hawkes Process with Stepwise Decay}
\description{
  Calculates the intensity function of a Hawkes process with stepwise decay.
}
\usage{
HawkesStep.cif(data, eval.pts, params, TT = NA, t.plus = FALSE)
}
\arguments{
  \item{data}{a data frame containing the event history, where each row represents one event. There must be columns named \code{"time"}, usually the number of days from some origin; and \code{"magnitude"} which is the event magnitude.}
  \item{eval.pts}{a vector or matrix. If a vector, the elements will be assumed to represent required evaluation times. A matrix must include a column named \code{"time"} at which the intensity function will be evaluated.}
  \item{params}{a vector of parameters values in the following order: \eqn{\code{c}(\lambda, \nu, \eta)}{\code{c}(\lambda, \nu, \eta)}.}
  \item{TT}{vector of length 2, being the time interval over which the integral of the conditional intensity function is to be evaluated.}
  \item{t.plus}{logical, \eqn{\lambda(t|{\cal H}_t)}{lambda(t|Ht)} is evaluated as \eqn{\lambda(t^+|{\cal H}_t)}{lambda(t^+|Ht)} if \code{TRUE}, else \eqn{\lambda(t^-|{\cal H}_t)}{lambda(t^-|Ht)}.}
}
\details{
}
\value{
  The first usage returns a vector containing the values of \eqn{\lambda(t)}{lambda(t)} evaluated at the specified points. In the second usage, it returns the value of the integral.
}
\references{Wang, T., Bebbington, M. and Harte, D. (2012) Markov-modulated Hawkes process with stepwise decay. The Annals of the Institute of Statistical Mathematics, 64, 521-544.}
\author{Ting Wang, 2009}
\note{}
\seealso{}
\keyword{models}
