\name{estSInt}
\alias{estSInt}

\title{Estimated Intensity Function}
\description{
  Calculates the estimated intensity function of an MMHP process.
}

\usage{
estSInt(tims, ti, lamb0, nu0, eta0, Q0, pai0, fortran = TRUE)
}

\arguments{
  \item{tims}{is a vector containing the times at which the intensity is evaluated}
  \item{ti}{is a vector containing the occurrence times of the observed process. Note that the first event is at time zero.}
  \item{lamb0}{is a vector containing the background rates of Hawkes processes with stepwise decay.}
  \item{nu0}{is a vector containing the parameter with values between 0 and 1.}
  \item{eta0}{is a vector containing the decay rates of Hawkes processes with stepwise decay.}
  \item{Q0}{is the infinitesimal generator matrix of the Markov process.}
  \item{pai0}{is the marginal probability distribution of the \eqn{m} hidden states at time zero.}
  \item{fortran}{is logical, and determines whether Fortran codes are used; default is \code{TRUE}.}
}
\details{
}
\value{
  \item{estStat}{a vector containing the estimated probability of the hidden state occupying each state at \code{tims}.}
  \item{lambdat}{a vector containing the estimated intensity functions at \code{tims}.}
}
\references{Wang, T., Bebbington, M. and Harte, D. (2012) Markov-modulated Hawkes process with stepwise decay. The Annals of the Institute of Statistical Mathematics, 64, 521-544.}
\author{Ting Wang, 2009}
\keyword{models}
