\name{simulatemmhp}
\alias{simulatemmhp}

\title{Simulate an MMHP process}
\description{
  Simulates a Markov-modulated Hawkes process with stepwise decay.
}
\usage{
simulatemmhp(n, object, data, initial, nsim = 1, seed = NULL)
}

\arguments{
  \item{n}{length of process.}
  \item{object}{a \code{list} object containing the parameters \eqn{Q}, \eqn{\lambda}, \eqn{\nu}, and \eqn{\eta}.}
  \item{data}{a data frame containing the event history, where each row represents one event. There must be columns named \code{"time"}, usually the number of days from some origin; and \code{"magnitude"} which is the event magnitude.}
  \item{initial}{integer, being the initial hidden Markov state \eqn{(1, \cdots, m)}.}
  \item{nsim}{nsim=1.}
  \item{seed}{an integer seed for the random number generator.}
}
\details{
}
\value{
  A data frame containing the original data before \code{TT[1]} and the simulated data after this date.
}
\references{Wang, T., Bebbington, M. and Harte, D. (2012) Markov-modulated Hawkes process with stepwise decay. The Annals of the Institute of Statistical Mathematics, 64, 521-544.}
\author{Ting Wang, 2009}
\keyword{methods}
\keyword{simulation}

